.586

.model flat

option casemap:none

include x.inc

.code


;__________________________________________________________________________________



_Roaknogs_Driver_Entry@8 PROC NEAR
	push EBP
	mov EBP, ESP
	sub ESP, 14h
	push EBX
	push ESI
	push EDI
	mov EDI, _RtlInitUnicodeString@8
	lea EAX, DWORD PTR [EBP - 12]					; pointer to device name unicode string
	mov ESI, 0
	push offset dev_name						; device name
	push EAX								; pointer to device name unicode string
	mov DWORD PTR [EBP - 4], ESI					; zero pointer to device name unicode string
	call EDI								; RtlInitUnicodeString function
	lea EAX, DWORD PTR [EBP-4]					; pointer to device name unicode string
	push EAX								; pointer to DeviceObject
	push 1								; TRUE
	push ESI								; 0
	lea EAX, DWORD PTR [EBP - 12]					; pointer to device name unicode string
	push 8010H								; device type in control code
	push EAX								; pointer to device name unicode string
	push ESI								; 0
	mov ESI, DWORD PTR [EBP + 8]					; DriverObject
	push ESI								; DriverObject
	call _IoCreateDevice@28
	mov EBX, EAX
	test EBX, EBX
	jl CreateDeviceFailed
	mov EAX, offset _Roak_Dispatch@8
	push offset dos_dev_name
	mov DWORD PTR [ESI + 112], EAX				; 70h PDISPATCH_IRP_MJ_DEVICE_CONTROL
	mov DWORD PTR [ESI + 64], EAX					; 40h PDISPATCH_IRP_MJ_CLOSE
	mov DWORD PTR [ESI + 56], EAX					; 38h PDISPATCH_IRP_MJ_CREATE
	lea EAX, DWORD PTR [EBP - 20]					; pointer to device link unicode string
	push EAX
	mov DWORD PTR [ESI + 52], offset _Roak_Unload@4		; PDRIVER_UNLOAD
	call EDI								; RtlInitUnicodeString function
	lea EAX, DWORD PTR [EBP - 12]					; pointer to device name unicode string
	push EAX
	lea EAX, DWORD PTR [EBP - 20]					; pointer to device link unicode string
	push EAX
	call _IoCreateSymbolicLink@8
	mov EBX, EAX
	test EBX, EBX
	jge SymbolicLinkCreated
	push DWORD PTR [EBP - 4]					; pointer to DeviceObject
	call _IoDeleteDevice@4
SymbolicLinkCreated:
CreateDeviceFailed:
	pop EDI
	mov EAX, EBX							; return from IoCreateSymbolicLink
	pop ESI
	pop EBX
	mov ESP, EBP
	pop EBP
	ret 8
_Roaknogs_Driver_Entry@8 ENDP


;__________________________________________________________________________________



_Roak_Dispatch@8 PROC NEAR
	push EBP
	mov EBP, ESP
	push ECX
	push EBX
	mov EBX, DWORD PTR [EBP + 12]					; 12 = 0Ch pIRP.AssociatedIrp.SystemBuffer
	push ESI
	push EDI
	mov EAX, DWORD PTR [EBX + 96]					; 96 = 60h pIRP.Tail.Overlay.CurrentStackLocation
	; [EAX + 4] = output buffer length
	; [EAX + 8] = input buffer length
	; [EAX + 12] = control code
	and DWORD PTR [EBX + 24], 0					; 24 = 18h IO_STATUS_BLOCK.Status
	and DWORD PTR [EBX + 28], 0					; 28 = 1Ch IO_STATUS_BLOCK.Information 
	mov ESI, DWORD PTR [EBX + 12]					; pointer to dStruct iobuffer
	mov ECX, DWORD PTR [EAX + 8]					; input buffer length
	cmp BYTE PTR [EAX], 0Eh						; if DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] == 14 == 0Eh
	mov DWORD PTR [EBP - 4], ESI					; pointer to dStruct iobuffer
	mov DWORD PTR [EBP + 12], ECX					; input buffer length
	jne LeaveDispatch
	mov EAX, DWORD PTR [EAX + 12]					; Control Code for IoDeviceControl
	cmp EAX, IOCTL_FUNCTION_ADDRESS
	je func_address
	cmp EAX, IOCTL_READ_HARD_DISK_SECTOR
	je read_disk
	cmp EAX, IOCTL_READ_MEMORY
	je read_mem
	cmp EAX, IOCTL_SEH
	je seh_ioc
	cmp EAX, IOCTL_SPEAKER_OFF
	je speak_off
	cmp EAX, IOCTL_SPEAKER_ON
	je speak_on
	jmp nither
	test ECX, ECX
	je nither
	;-----------------------------------------------------------------------------------
func_address:								; IOCTL_FUNCTION_ADDRESS
	;-----------------------------------------------------------------------------------
	push ESI
	push EDI
	mov ECX, sizeof _sDataStruct					; 524 even #
	mov ESI, DWORD PTR [EBP - 4]
	mov EDI, offset dStruct
	shr ECX, 2
	rep movsd
	and ECX, 3
	rep movsb
	mov EAX, dStruct.osv						; retrieve os version
	mov my_os_version, EAX						; to be sent back later
	pop EDI
	pop ESI
	push ESI
	push EDI
	push EBX
	call _Call_Function_By_Address@0				; message returned in ESI
	mov EAX, my_os_version						; send back os version
	mov dStruct.Status, EAX						; status returned in EAX = os version #
	mov EBX, 0
esi_function_loop:
	mov AL, BYTE PTR [ESI + EBX]
	mov dStruct.b[EBX], AL
	inc EBX
	.if EBX < 512
		jmp esi_function_loop
	.endif
	pop EBX
	pop EDI
	pop ESI
	jmp no_more_so_send_struct
	;-----------------------------------------------------------------------------------
read_disk:									; IOCTL_READ_HARD_DISK_SECTOR
	;-----------------------------------------------------------------------------------
	push ESI
	push EDI
	mov ECX, sizeof _sDataStruct					; 524 even #
	mov ESI, DWORD PTR [EBP - 4]
	mov EDI, offset dStruct
	shr ECX, 2
	rep movsd
	and ECX, 3
	rep movsb
	pop EDI
	pop ESI
	push ESI								; saves for future call
	push EDI
	push EBX
	push DWORD PTR [dStruct.c4]					; call actual sector read
	push DWORD PTR [dStruct.c3]
	push DWORD PTR [dStruct.c2]
	push DWORD PTR [dStruct.c1]
	call _Read_Hard_Disk_Sector@16				; memory returned in ESI
	mov dStruct.Status, EAX						; status returned in EAX = 17
	mov EBX, 0
esi_hd_loop:
	mov AL, BYTE PTR [ESI + EBX]
	mov dStruct.b[EBX], AL
	inc EBX
	.if EBX < 512
		jmp esi_hd_loop
	.endif
	pop EBX
	pop EDI
	pop ESI
	jmp no_more_so_send_struct
	;-----------------------------------------------------------------------------------
read_mem:									; IOCTL_READ_MEMORY
	;-----------------------------------------------------------------------------------
	push ESI								; saves for future call
	push EDI
	push EBX
	call _Read_Memory@0						; memory is put into ESI
	mov dStruct.Status, EAX						; status returned in EAX = 13
	mov EBX, 0
esi_mem_loop:
	mov AL, BYTE PTR [ESI + EBX]
	mov dStruct.b[EBX], AL
	inc EBX
	.if EBX < 512
		jmp esi_mem_loop
	.endif
	pop EBX
	pop EDI
	pop ESI
	jmp no_more_so_send_struct
	;-----------------------------------------------------------------------------------
seh_ioc:									; IOCTL_SEH
	;-----------------------------------------------------------------------------------
	push ESI
	push EDI
	mov ECX, sizeof _sDataStruct					; 524 even #
	mov ESI, DWORD PTR [EBP - 4]
	mov EDI, offset dStruct
	shr ECX, 2
	rep movsd
	and ECX, 3
	rep movsb
	pop EDI
	pop ESI
	push ESI								; saves for future call
	push EDI
	push EBX
	mov EAX, 0								; 13 for parameter 2
	mov AL, dStruct.c2
	push EAX
	mov EAX, 0								; 1 for parameter 1 to raise exception to handle
	mov AL, dStruct.c1
	push EAX
	call _Roaknogs_Structured_Exception_Handler@8
	mov dStruct.Status, EAX						; status 
	mov EBX, 0
esi_seh_loop:
	mov AL, BYTE PTR [ESI + EBX]
	mov dStruct.b[EBX], AL
	inc EBX
	.if EBX < 512
		jmp esi_seh_loop
	.endif
	pop EBX
	pop EDI
	pop ESI
	jmp no_more_so_send_struct
	;-----------------------------------------------------------------------------------
speak_off:									; IOCTL_SPEAKER_OFF
	;-----------------------------------------------------------------------------------
	mov ECX, 512							; prepare display
	mov ESI, offset roak_msg_off
	mov EDI, offset dStruct.b
	shr ECX, 2
	rep movsd
	call _Speaker_Off@0						; call my external function
	mov dStruct.Status, 11						; status = 11
	jmp no_more_so_send_struct
	;-----------------------------------------------------------------------------------
speak_on:									; IOCTL_SPEAKER_ON
	;-----------------------------------------------------------------------------------
	mov ECX, 512							; prepare display
	mov ESI, offset roak_msg_on
	mov EDI, offset dStruct.b
	shr ECX, 2
	rep movsd
	push 5								; call my external function
	and ECX, 3
	push 2
	rep movsb
	mov dStruct.Status, 9						; status = 9
	call _Speaker_On@8
	jmp no_more_so_send_struct
no_more_so_send_struct:
	mov EAX, DWORD PTR [EBP + 12]					; iobuffer length = 524 bytes here
	mov EDI, DWORD PTR [EBP - 4]					; pointer to dStruct iobuffer
	mov ECX, EAX
	mov EDX, ECX
	mov ESI, offset dStruct
	shr ECX, 2
	rep movsd
	mov ECX, EDX
	and ECX, 3
	rep movsb
	mov DWORD PTR [EBX + 28], EAX
	jmp LeaveDispatch
nither:
	mov DWORD PTR [EBX + 24], 0C000000Dh			; STATUS_INVALID_PARAMETER
LeaveDispatch:
	mov ESI, DWORD PTR [EBX + 24]
	xor DL, DL
	mov ECX, EBX
	push EDX
	push ECX
	call _IoCompleteRequest@8
	mov EAX, ESI
	pop EDI
	pop ESI
	pop EBX
	mov ESP, EBP
	pop EBP
	ret 8
_Roak_Dispatch@8 ENDP


;__________________________________________________________________________________



END



;;;;;;;;;;;;;;;;;;;;;;;;;;;;















;;;;;;;;;;;;;;;;;;;;;;;;;;;;;












;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;















;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;














;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;







;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;















;;;;;;;;;;;;;;;;;;;;;;;;;;;;;












;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;















;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;














;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;










;;;;;;;;;;;;;;;;;;;;;;;;;










;;;;;;;;;;;;;;;;






