


;.......................................................................................
; MACROS
;.......................................................................................



	CTL_CODE MACRO DeviceType,Function,Method,Access
	EXITM %(((DeviceType) SHL 16) OR ((Access) SHL 14) OR ((Function) SHL 2) OR (Method))
	ENDM



;.......................................................................................
; EQUS
;.......................................................................................


 
	IOCTL_SPEAKER_ON					EQU CTL_CODE(8010h, 820h, 0, 0)
	IOCTL_SPEAKER_OFF					EQU CTL_CODE(8010h, 830h, 0, 0)
	IOCTL_READ_HARD_DISK_SECTOR			EQU CTL_CODE(8010h, 840h, 0, 0)
	IOCTL_READ_MEMORY					EQU CTL_CODE(8010h, 850h, 0, 0)
	IOCTL_FUNCTION_ADDRESS				EQU CTL_CODE(8010h, 860h, 0, 0)
	IOCTL_SEH						EQU CTL_CODE(8010h, 870h, 0, 0)
	IOCTL_UNKNOWN1					EQU CTL_CODE(8010h, 880h, 0, 0)
	IOCTL_UNKNOWN2					EQU CTL_CODE(8010h, 890h, 0, 0)



;.......................................................................................
; PUBLICS
;.......................................................................................



	PUBLIC	_Roaknogs_Driver_Entry@8
	PUBLIC	_Roak_Dispatch@8



;.......................................................................................
; MY EXTERNALS
;.......................................................................................



	EXTRN		_Call_Function_By_Address@0:NEAR
	EXTRN		_Clean_String@4:NEAR
	EXTRN		_Compare_Strings@8:NEAR
	EXTRN		_Convert_Number_To_ASCII@4:NEAR
	EXTRN		_Day_Of_Week@12:NEAR
	EXTRN		_Get_Base@0:NEAR
	EXTRN		_Get_Pointer_To_Module_List@0:NEAR
	EXTRN		_Read_Hard_Disk_Sector@16:NEAR
	EXTRN		_Read_Memory@0:NEAR
	EXTRN		_Roaknogs_Structured_Exception_Handler@8:NEAR
	EXTRN		_Roak_Unload@4:NEAR
	EXTRN		_Space_Function_Name@4:NEAR
	EXTRN		_Speaker_Off@0:NEAR
	EXTRN		_Speaker_On@8:NEAR
	EXTRN		_Time_Date_Stamp_Converteor@4:NEAR
	EXTRN		_Write_Data_To_File@16:NEAR
	EXTRN		_Write_PIMAGE_EXPORT_DIRECTORY_To_File@8:NEAR
	EXTRN		_Write_PIMAGE_NT_HEADER_To_File@8:NEAR
	EXTRN		_Write_Table_Of_Functions_To_File@12:NEAR



;.......................................................................................
; LIBRARY EXTERNALS
;.......................................................................................



	EXTRN		_ExRaiseAccessViolation@0:NEAR
	EXTRN		_IoCreateDevice@28:NEAR
	EXTRN		_IoCreateSymbolicLink@8:NEAR
	EXTRN 	_IoCompleteRequest@8:NEAR
	EXTRN		_IoDeleteDevice@4:NEAR
	EXTRN		_RtlInitUnicodeString@8:NEAR



;.......................................................................................
; DATA
;.......................................................................................



.data
_sDataStruct				STRUC
	Status				DD					?
	osv					DD					?
	c1					DB					?
	c2					DB					?
	c3					DB					?
	c4					DB					?
	b					DB					512 DUP(?)
_sDataStruct				ENDS
	dStruct				_sDataStruct			<>
	dev_name				DB					'\', 0h, 'D', 0h, 'e', 0h, 'v', 0h, 'i', 0h, 'c', 0h, 'e', 0h, '\', 0h, 'R', 0h, 'O', 0h, 'A', 0h, 'K', 0h, 0h,	0h
	dos_dev_name			DB					'\', 0h, 'D', 0h, 'o', 0h, 's', 0h, 'D', 0h, 'e', 0h, 'v', 0h, 'i', 0h, 'c', 0h, 'e', 0h, 's', 0h, '\', 0h, 'R', 0h, 'O', 0h, 'A', 0h, 'K', 0h, 0h, 0h
	roak_msg_on				DW					0, 0, 0, 0, 'R', 'O', 'A', 'K', ' ', 'N', 'O', 'G', ' ', 'S', 'A', 'Y', 'S', ' ', 'S', 'P', 'E', 'A', 'K', 'E', 'R', ' ', 'O', 'N', '!', 500 dup (0)
	roak_msg_off			DW					0, 0, 0, 0, 'R', 'O', 'A', 'K', ' ', 'N', 'O', 'G', ' ', 'S', 'A', 'Y', 'S', ' ', 'S', 'P', 'E', 'A', 'K', 'E', 'R', ' ', 'O', 'F', 'F', '!', 500 dup (0)
	my_os_version			DD					?	



;.......................................................................................
; END
;.......................................................................................


