


;.....................................................................
; INCLUDES
;.....................................................................



	include				windows.inc
	include				gdi32.inc
	include				user32.inc
	include				kernel32.inc
	include				advapi32.inc
	include				winmm.inc
	include				masm32.inc
	includelib				gdi32.lib
	includelib				user32.lib
	includelib				kernel32.lib
	includelib				advapi32.lib
	includelib				winmm.lib
	includelib				masm32.lib



;.....................................................................
; PROTOS
;.....................................................................



	Choose_Roak_Function		PROTO :DWORD
	Create_Edit_Box			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
	Create_Push_Button		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
	Creation_Procedure		PROTO :DWORD
	Display_Return			PROTO :DWORD, :DWORD
	Filter_Input			PROTO :DWORD, :DWORD, :DWORD, :DWORD
	Interchange_With_Roak		PROTO :DWORD, :DWORD
	Show_String				PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
	WinMain				PROTO :DWORD, :DWORD, :DWORD, :DWORD 
	WndProc				PROTO :DWORD, :DWORD, :DWORD, :DWORD 



;........................................................................
; MACROS
;........................................................................



	CTL_CODE MACRO DeviceType,Function,Method,Access
	EXITM %(((DeviceType) SHL 16) OR ((Access) SHL 14) OR ((Function) SHL 2) OR (Method))
	ENDM



;........................................................................
; CONTROL CODES
;........................................................................



	IOCTL_SPEAKER_ON			EQU CTL_CODE(8010h, 820h, 0, 0)
	IOCTL_SPEAKER_OFF			EQU CTL_CODE(8010h, 830h, 0, 0)
	IOCTL_READ_HARD_DISK_SECTOR	EQU CTL_CODE(8010h, 840h, 0, 0)
	IOCTL_READ_MEMORY			EQU CTL_CODE(8010h, 850h, 0, 0)
	IOCTL_FUNCTION_ADDRESS		EQU CTL_CODE(8010h, 860h, 0, 0)
	IOCTL_SEH				EQU CTL_CODE(8010h, 870h, 0, 0)
	IOCTL_UNKNOWN1			EQU CTL_CODE(8010h, 880h, 0, 0)
	IOCTL_UNKNOWN2			EQU CTL_CODE(8010h, 890h, 0, 0)



;.....................................................................
; DATA
;.....................................................................



.data



;........................................................................
; Choose_Roak_Function PROCEDURE VARIABLES
;........................................................................



_sDataStruct				STRUC
	Status				DD ?
	osv					DD ?
	c1					DB ?
	c2					DB ?
	c3					DB ?
	c4					DB ?
	b					DB 512 DUP(?)
_sDataStruct				ENDS
	dStruct				_sDataStruct <>
	hDriver				DD 0
	dwBytesReturned			DD 0



;........................................................................
; Create_Push_Button PROCEDURE VARIABLES
;........................................................................



	button_class			DB "BUTTON", 0



;........................................................................
; Create_Edit_Box PROCEDURE VARIABLES
;........................................................................



	edit_class				DB "EDIT", 0



;........................................................................
; Creation_Procedure PROCEDURE VARIABLES
;........................................................................



	last_input				DD 0
	hEdit1				DD 0
	hEdit2				DD 0
	hEdit3				DD 0
	hEdit4				DD 0
	hEdit5				DD 0
	hEdit6				DD 0
	lbl1					DB 'Enter 1 For Exception Handling:', 0
	lbl2					DB 'Enter 13 For Post SEH Part:', 0
	lbl3					DB 'Enter Cylinder #:', 0
	lbl4					DB 'Enter Sector:', 0
	lbl5					DB 'Enter Head:', 0
	lbl6					DB 'Status:', 0
	exit_rnsexe_button		DB 'EXIT', 0
	play_roakn_button			DB 'PLAY WAVE', 0
	speaker_on_button			DB 'SPEAKER ON', 0
	speaker_off_button		DB 'TURN SPEAKER OFF', 0
	read_drive_button			DB 'READ DISK SECTOR', 0
	read_serial_button		DB 'READ MAIN BOARD SERIAL #', 0
	function_ad_button		DB 'CALL _atoi64(str) BY ADDRESS', 0
	sexception_button			DB 'STRUCTURED EXCEPTION HANDLING', 0



;........................................................................
; Get_Os_Version PROCEDURE VARIABLES
;........................................................................



	my_os_test				DD ?
	ME_msg				DB 10, 13, 10, 13, '     Your operating system is Windows ME.', 10, 13, 0
	NT4_msg				DB 10, 13, 10, 13, '     Your operating system is Windows NT 4.0.', 10, 13, 0
	NT351_msg				DB 10, 13, 10, 13, '     Your operating system is Windows NT 3.51.', 10, 13, 0
	W98SE_msg				DB 10, 13, 10, 13, '     Your operating system is Windows 98.', 10, 13, 0
	W95_msg				DB 10, 13, 10, 13, '     Your operating system is Windows 95.', 10, 13, 0
	W2K_msg				DB 10, 13, 10, 13, '     Your operating system is Windows 2000.', 10, 13, 0
	WXP_msg				DB 10, 13, 10, 13, '     Your operating system is Windows XP.', 10, 13, 0
	version_msg				DB 10, 13, 10, 13, '     RK NOG IS PERFECT IN EVERY WAY!'
						DB 10, 13, 10, 13, '     LET US LOOK AT YOUR OPERATING SYSTEM . . .'
						DB 10, 13, 10, 13, '     dwOSVersionInfoSize = %d'
						DB         10, 13, '     dwMajorVersion      = %d'
						DB         10, 13, '     dwMinorVersion      = %d'
						DB         10, 13, '     dwBuildNumber       = %d'
						DB         10, 13, '     dwPlatformId        = %d', 0
	additional_msg			DB 10, 13, 10, 13, '     Additional information about your operating system:', 10, 13, '     %s', 10, 13, 10, 13, 0
	version_buffer			DB 1000 dup(?)
	version_mb_msg			DB 2000 dup(?)
	version_mb_title			DB 'Version', 0


	comment $
	version	dwPlatFormID	dwMajorVersion	dwMinorVersion	dwBuildNumber 
	95		1			4			0 			950
	95 SP1	1			4			0			>950 && <=1080 
	95 OSR2	1			4			<10 			>1080 
	98		1			4			10			1998 
	98 SP1	1			4			10			>1998 && <2183 
	98 SE		1			4			10			>=2183 
	ME		1 			4			90 			3000 
	NT 3.51	2 			3			51 			1057 
	NT 4		2 			4			0 			1381
	2000		2 			5			0			2195 
	XP		2 			5			1
	CE 1.0 	3			1			0 
	CE 2.0 	3			2			0 
	CE 2.1 	3			2			1 
	CE 3.0 	3			3			0 
	$



;........................................................................
; Interchange_With_Roak PROCEDURE VARIABLES
;........................................................................



	test_counter			DD 0
	interchange_buffer		DB 512 dup(?)
	interchange_msg			DB 'Error code = %d in call to function %d.', 0
	interchange_error_mb_title	DB 'ERROR IN CALL TO ROAK.SYS', 0



;........................................................................
; Initialize_Roak_Sys PROCEDURE VARIABLES
;........................................................................



	ServiceStatus 			SERVICE_STATUS <>
	service_handle 			DD 0
	manager_handle			DD 0
	size_of_file_path			DD 0
	file_path				DB 512 DUP(0)
	sys_name				DB "roak", 0
	create_roak				DB "\\.\roak", 0
	hInstance				DD 0



;........................................................................
; MessageBox VARIABLES
;........................................................................



	szDisplayName			DB 'Freehafer''s Driver Loader  2003 INNEA PUBLISHING CO.', 0 
	about_mb_msg			DB 'Assembled with MASM32 Version 7.  Download it at:', 10, 13, 10, 13, 'http://www.movsd.com/', 0
	bad_input_mb_title		DB 'BAD INPUT!', 0
	bad_input_mb_msg			DB 'You may only enter digits from 0 to 9!', 0 
	flow_mb_title			DB 'ROAK.SYS FLOW CHART', 0
	flow_mb_msg				DB 'Roaknogs_Driver_Entry@8', 13, 10
						DB '            Roak_Dispatch@8', 13, 10
						DB '                        Call_Function_By_Address@0', 13, 10
						DB '                                    Get_Base@0', 13, 10
						DB '                                                Clean_String@4', 13, 10
						DB '                                                Convert_Number_To_ASCII@4', 13, 10
						DB '                                                Get_Pointer_To_Module_List@0', 13, 10
						DB '                                                Write_Data_To_File@16', 13, 10
						DB '                                    Write_PIMAGE_NT_HEADER_To_File@8', 13, 10
						DB '                                                Convert_Number_To_ASCII@4', 13, 10
						DB '                                                Time_Date_Stamp_Converteor@4', 13, 10
						DB '                                                            Convert_Number_To_ASCII@4', 13, 10
						DB '                                                            Day_Of_Week@12', 13, 10
						DB '                                                Write_Data_To_File@16', 13, 10
						DB '                                                Write_PIMAGE_EXPORT_DIRECTORY_To_File@8', 13, 10
						DB '                                                            Convert_Number_To_ASCII@4', 13, 10
						DB '                                                            Time_Date_Stamp_Converteor@4', 13, 10
						DB '                                                                        Convert_Number_To_ASCII@4', 13, 10
						DB '                                                                        Day_Of_Week@12', 13, 10
						DB '                                                            Write_Data_To_File@16', 13, 10
						DB '                                    Write_Table_Of_Functions_To_File@12', 13, 10
						DB '                                                Compare_Strings@8', 13, 10
						DB '                                                Convert_Number_To_ASCII@4', 13, 10
						DB '                                                Space_Function_Name@4', 13, 10
						DB '                                                Write_Data_To_File@16', 13, 10
						DB '                        Read_Hard_Disk_Sector@16', 13, 10
						DB '                                    Write_Data_To_File@16', 13, 10
						DB '                        Read_Memory@0', 13, 10
						DB '                                    Write_Data_To_File@16', 13, 10
						DB '                        Roaknogs_Structured_Exception_Handler@8', 13, 10
						DB '                        Speaker_Off@0', 13, 10
						DB '                        Speaker_On@8', 13, 10
						DB '             Roak_Unload@4', 13, 10, 0
	return_mb_title			DB 'ROAK.SYS RETURNS:', 0
	return_mb_msg			DB 1000 dup(?)
	what_mb_title			DB 'WHAT CAN YOU DO WITH THIS PROGRAM?', 0
	what_mb_msg				DB 'Call functions in roak.sys in Windows 2000/XP.', 10, 13, 10, 13, '2003 Inniea Publishing Co.', 10, 13, 10, 13, 'RK NOG!', 0
	biblio_mb_title			DB 'BIBLIOGRAPHY', 0
	biblio_mb_msg			DB '     1. http://assembly.ifrance.com/assembly/WinNT.txt', 10, 13, '     Assembly Code, Pulsar Fevrier.', 10, 13, 10, 13
						DB '     2. http://board.win32asmcommunity.net/showthread.php?s=&threadid=1961', 10, 13, '     Control Code, Bit7, BitRAKE.', 10, 13, 10, 13
						DB '     3. http://board.win32asmcommunity.net/showthread.php?s=&threadid=2613', 10, 13, '     Linking, jmp $FCE2.', 10, 13, 10, 13
						DB '     4. http://board.win32asmcommunity.net/showthread.php?s=&threadid=3493', 10, 13, '     Structure And Use Of DD, madprgmr.', 10, 13, 10, 13
						DB '     5. http://board.win32asmcommunity.net/showthread.php?s=&threadid=6086', 10, 13, '     Pointer Arithmetic, Dr. Manhattan.', 10, 13, 10, 13
						DB '     6. http://www.anticracking.sk/EliCZ/', 10, 13, '     Passing Data, EliCZ.', 10, 13, 10, 13
						DB '     7. http://www.comrade64.com/', 10, 13, '     Structured Exception Handling, comrade.', 10, 13, 10, 13
						DB '     8. http://www.google.com', 10, 13, '     Create & Restore Handler, Anatoly Vorobey.', 10, 13, 10, 13
						DB '     9. http://www.internals.com', 10, 13, '     Flow Chart, Yariv Kaplan.', 10, 13, 10, 13
						DB '     A. http://www.newriders.com/native', 10, 13, '     Native Application Program Interface Reference, Nebbett.', 10, 13, 10, 13
						DB '     B. http://www.orgon.com/w2k_internals/', 10, 13, '     Calling Ntdll.dll Functions From Ring Zero, Schreiber.', 10, 13, 10, 13
						DB '     C. http://www.sysinternals.com/files/physmem.zip', 10, 13, '     Mapping Memory With ZwOpenSection, Russinovich.', 0
	exe_flow_mb_title			DB 'Z.EXE FLOW CHART', 0
	exe_flow_mb_msg			DB 'WinMain@16', 10, 13
						DB '            WndProc@16', 10, 13
						DB '                        Creation_Procedure@4', 10, 13
						DB '                                    Create_Edit_Box@28', 10, 13
						DB '                                    Create_Push_Button@28', 10, 13
						DB '                                    Filter_Input@16', 10, 13
						DB '                                    Show_String@28', 10, 13
						DB '                        Interchange_With_Roak@8', 10, 13
						DB '                                    Get_Os_Version@0', 10, 13
						DB '                                    Initialize_Roak_Sys@0', 10, 13
						DB '                                    Choose_Roak_Function@4', 10, 13
						DB '                                    Display_Return@8', 10, 13
						DB '                                    Shut_Down_Roak', 10, 13
						DB '                        Choose_Roak_Function@4', 10, 13
						DB '                        Display_Return@8', 10, 13
						DB '                        Shut_Down_Roak@0', 10, 13
						DB '                        Time_Procedure@0', 0
	why_mb_title			DB 'WHY DO I PROGRAM THE WAY I DO?', 0
	why_mb_msg				DB 'It may take the computer fewer cycles to execute xor EAX, EAX.', 10, 13, 10, 13, 'However it takes RK NOG less time to type mov EAX, 0.', 13, 10, 13, 10 
						DB 'RK NOG is perfect in every way.', 0
	not_you_mb_title			DB 'WRONG OPERATING SYSTEM!', 0
	not_you_mb_msg			DB 'This is for Windows 2000/XP!', 0



;........................................................................
; Show_String PROCEDURE VARIABLES
;........................................................................



	static_class			DB "STATIC", 0


;...............................................................................
; Time_Procedure PROCEDURE VARIABLES
;...............................................................................



	system_time				SYSTEMTIME <>
	stYear				DD 0
	stDay					DD 0
	stMonth				DD 0
	stHour				DD 0
	stMinute				DD 0
	stSecond				DD 0
	stMillisecond			DD 0
	stDayOfWeek				DD 0
	szAM					DB ' AM.', 0
	szPM					DB ' PM.', 0
	APM					DB 10 dup(?)
	szDate_Time				DB 'THE DATE IS %.2d/%.2d/%.2d %10.10s.  THE TIME IS %.2d:%.2d:%.2d:%.3d %s', 0
	time_date_string_buffer		DB 500 dup(?)
	day_string				DB 10 dup(?)
	day_array				DB 'Sunday    Monday    Tuesday   Wednesday Thursday  Friday    Saturday  '



;........................................................................
; WndProc PROCEDURE VARIABLES
;........................................................................



	track					DD 0
	sector				DD 0
	cylinder				DD 0
	SEH_NUM_1				DD 0
	SEH_NUM_2				DD 0
	STATUS_RETURN			DD 0
	clock_test				DD 0
	no_clock_buf			DB 150 dup('~')
	wave_path				DB 'roak.wav', 0



;........................................................................
; WinMain PROCEDURE VARIABLES
;........................................................................



	szClassName				DB 'freehafer', 0
	hWnd					DD 0



;........................................................................
; END
;........................................................................




